Reinforcement StraightRebar
|
Menu location |
---|
3D/BIM → Reinforcement tools → Straight Rebar |
Workbenches |
Reinforcement, BIM |
Default shortcut |
None |
Introduced in version |
0.17 |
See also |
None |
Description
The Reinforcement StraightRebar tool allows the user to create a set of straight reinforcing bars inside an Arch Structure object.
This tool is part of the Reinforcement Workbench, an external workbench that can be installed with the Addon Manager.
Two sets of straight reinforcement bars inside an Arch Structure
Usage
- Select any face of a previously created
Arch Structure object.
- Then select
Straight Rebar from the rebar tools.
- A task panel will pop-out on the left side of the screen as shown below.
- Select the desired orientation.
- Give the inputs like 'Front cover', 'Right side cover', 'Left side cover', 'Bottom cover' and 'Diameter' of the rebar.
- Select the mode of distribution either 'Amount' or 'Spacing'.
- If spacing is selected, a user can also opt for custom spacing.
- Pick Selected Face is used to verify or change the face for rebar distribution.
- Click OK or Apply to generate the rebars.
- Click Cancel to exit the task panel.
Task panel for the tool
Properties
- DataOrientation: It decides the orientation of the rebar (like a bottom, top, right and left).
- DataFront Cover: The distance between rebar and selected face.
- DataRight Cover: The distance between the right end of the rebar to right face of the structure.
- DataLeft Cover: The distance between the left end of the rebar to the left face of the structure.
- DataCover along: These property facilities the user to specify either top or bottom cover.
- DataBottom Cover: The distance between rebar from the bottom face of the structure.
- DataTop Cover: The distance between rebar from the top face of the structure.
- DataAmount: The amount of rebars.
- DataSpacing: The distance between the axes of each bar.
Scripting
See also: Arch API, Reinforcement API and FreeCAD Scripting Basics.
The Reinforcement StraightRebar tool can be used in macros and from the Python console by using the following function:
Rebar = makeStraightRebar(f_cover, coverAlong, rt_cover, lb_cover,
diameter, amount_spacing_check, amount_spacing_value, orientation="Horizontal",
structure=None, facename=None)
- Creates a
Rebar
object from the givenstructure
, which is an Arch Structure, andfacename
, which is a face of that structure.- If no
structure
norfacename
are given, it will take the user selected face as input.
- If no
f_cover
,coverAlong
,rt_cover
, andlb_cover
are inner offset distances for the rebar elements with respect to the faces of the structure.f_cover
is the frontal cover offset.coverAlong
is a tuple(position, value)
that defines the offset value in one position (top, bottom, left, right) depending on theorientation
.rt_cover
is either the right or the top cover offset, depending on the value ofcoverAlong
andorientation
.lb_cover
is either the left or the bottom cover offset, depending on the value ofcoverAlong
andorientation
.
diameter
is the diameter of the reinforcement bars inside the structure.amount_spacing_check
if it isTrue
it will create as many reinforcement bars as given byamount_spacing_value
; if it isFalse
it will create reinforcement bars separated by the numerical value ofamount_spacing_value
.amount_spacing_value
specifies the number of reinforcement bars, or the value of the separation between them, depending onamount_spacing_check
.orientation
specifies the orientation of the rebar; it can be"Horizontal"
or"Vertical"
.
Depending on the orientation of the rebar, the function can be called in two general ways by setting coverAlong
appropriately.
The rebar is horizontal
Rebar = makeStraightRebar(f_cover, ("Top Side", value), right_cover, left_cover, ...)
Rebar = makeStraightRebar(f_cover, ("Bottom Side", value), right_cover, left_cover, ...)
coverAlong
is a tuple with either a"Top Side"
or a"Bottom Side"
offsetvalue
.- In this case
rt_cover
refers to theright_cover
offset, andlb_cover
refers to theleft_cover
offset.
The rebar is vertical
Rebar = makeStraightRebar(f_cover, ("Left Side", value), top_cover, bottom_cover, ...)
Rebar = makeStraightRebar(f_cover, ("Right Side", value), top_cover, bottom_cover, ...)
coverAlong
is a tuple with either a"Left Side"
or a"Right Side"
offsetvalue
.- In this case
rt_cover
refers to thetop_cover
offset, andlb_cover
refers to thebottom_cover
offset.
Example horizontal
import Arch, Draft, StraightRebar
Structure = Arch.makeStructure(length=1000, width=1000, height=400)
Structure.ViewObject.Transparency = 80
FreeCAD.ActiveDocument.recompute()
Rebar = StraightRebar.makeStraightRebar(50, ("Bottom Side", 20), 100, 100,
12, True, 5, "Horizontal", Structure, "Face4")
Rebar.ViewObject.ShapeColor = (0.9, 0.0, 0.0)
Rebar2 = StraightRebar.makeStraightRebar(50, ("Bottom Side", 50), 100, 100,
12, True, 5, "Horizontal", Structure, "Face6")
Rebar2.ViewObject.ShapeColor = (0.0, 0.0, 0.9)
Example vertical
import Arch, Draft, StraightRebar
Structure2 = Arch.makeStructure(length=1000, width=1000, height=400)
Structure2.ViewObject.Transparency = 80
Draft.move(Structure2, FreeCAD.Vector(1500, 0, 0))
FreeCAD.ActiveDocument.recompute()
Rebar3 = StraightRebar.makeStraightRebar(50, ("Left Side", 20), 100, 100,
12, True, 5, "Vertical", Structure2, "Face4")
Rebar3.ViewObject.ShapeColor = (0.9, 0.5, 0.0)
Rebar4 = StraightRebar.makeStraightRebar(50, ("Left Side", 50), 100, 100,
12, True, 5, "Vertical", Structure2, "Face6")
Rebar4.ViewObject.ShapeColor = (0.0, 0.5, 0.5)
Edition of rebar
You can change the properties of the rebar with the following function:
editStraightRebar(Rebar, f_cover, coverAlong, rt_cover, lb_cover,
diameter, amount_spacing_check, amount_spacing_value, orientation,
structure=None, facename=None)
Rebar
is a previously createdStraightRebar
object.- The other parameters are the same as required by the
makeStraightRebar()
function. structure
andfacename
may be omitted so that the rebar stays in the original structure.
Example:
import StraightRebar
StraightRebar.editStraightRebar(Rebar, 50, ("Top Side", 20), 100, 100,
24, True, 7, "Horizontal")
StraightRebar.editStraightRebar(Rebar2, 50, ("Top Side", 50), 100, 100,
24, True, 7, "Horizontal")
StraightRebar.editStraightRebar(Rebar3, 50, ("Right Side", 20), 100, 100,
24, True, 7, "Vertical")
StraightRebar.editStraightRebar(Rebar4, 50, ("Right Side", 50), 100, 100,
24, True, 7, "Vertical")
- 2D drafting: Sketch, Line, Polyline, Circle, Arc, Arc by 3 points, Fillet, Ellipse, Polygon, Rectangle, B-spline, Bézier curve, Cubic Bézier curve, Point
- 3D/BIM: Project, Site, Building, Level, Space, Wall, Curtain Wall, Column, Beam, Slab, Door, Window, Pipe, Pipe Connector, Stairs, Roof, Panel, Frame, Fence, Truss, Equipment
- Reinforcement tools: Custom Rebar, Straight Rebar, U-Shape Rebar, L-Shape Rebar, Stirrup, Bent-Shape Rebar, Helical Rebar, Column Reinforcement, Beam Reinforcement, Slab Reinforcement, Footing Reinforcement
- Generic 3D tools: Profile, Box, Shape builder..., Facebinder, Objects library, Component, External reference
- Annotation: Text, Shape from text, Aligned dimension, Horizontal dimension, Vertical dimension, Leader, Label, Axis, Axes System, Grid, Section Plane, Hatch, Page, View, Shape-based view
- Snapping: Snap lock, Snap endpoint, Snap midpoint, Snap center, Snap angle, Snap intersection, Snap perpendicular, Snap extension, Snap parallel, Snap special, Snap near, Snap ortho, Snap grid, Snap working plane, Snap dimensions, Toggle grid, Working Plane Top, Working Plane Front, Working Plane Side
- Modify: Move, Copy, Rotate, Clone, Create simple copy, Make compound, Offset, 2D Offset..., Trimex, Join, Split, Scale, Stretch, Draft to sketch, Upgrade, Downgrade, Add component, Remove component, Array, Path array, Polar array, Point array, Cut with plane, Mirror, Extrude..., Difference, Union, Intersection
- Manage: BIM Setup..., Views manager, Manage project..., Manage doors and windows..., Manage IFC elements..., Manage IFC quantities..., Manage IFC properties..., Manage classification..., Manage layers..., Material, Schedule, Preflight checks..., Annotation styles...
- Utils: Toggle bottom panels, Move to Trash, Working Plane View, Select group, Set slope, Create working plane proxy, Add to construction group, Split Mesh, Mesh to Shape, Select non-manifold meshes, Remove Shape from Arch, Close Holes, Merge Walls, Check, Toggle IFC Brep flag, Toggle subcomponents, Survey, IFC Diff, IFC explorer, Create IFC spreadsheet..., Image plane, Unclone, Rewire, Glue, Reextrude
- Panel tools: Panel, Panel Cut, Panel Sheet, Nest
- Structure tools: Structure, Structural System, Multiple Structures
- IFC tools: IFC Diff..., IFC Expand, Make IFC project, IfcOpenShell update
- Nudge: Nudge Switch, Nudge Up, Nudge Down, Nudge Left, Nudge Right, Nudge Rotate Left, Nudge Rotate Right, Nudge Extend, Nudge Shrink
- Additional: Preferences, Fine tuning, Import Export Preferences, IFC, DAE, OBJ, JSON, 3DS, SHP

- Getting started
- Installation: Download, Windows, Linux, Mac, Additional components, Docker, AppImage, Ubuntu Snap
- Basics: About FreeCAD, Interface, Mouse navigation, Selection methods, Object name, Preferences, Workbenches, Document structure, Properties, Help FreeCAD, Donate
- Help: Tutorials, Video tutorials
- Workbenches: Std Base, Assembly, BIM, CAM, Draft, FEM, Inspection, Material, Mesh, OpenSCAD, Part, PartDesign, Points, Reverse Engineering, Robot, Sketcher, Spreadsheet, Surface, TechDraw, Test Framework
- Hubs: User hub, Power users hub, Developer hub